function testpos(file,opt)
% test driver for RTKDEMO
%
%          Copyright (C) 2006 by T.TAKASU, All rights reserved.
%
% version: $Revision: 1 $ $Date: 06/01/29 6:53 $
% history: 2006/01/26 1.1 new
if nargin<2, opt=''; end

p=textread(file,'','commentstyle','matlab');

switch (opt)
case '1',  rr=[-3.9762191879E+06;3.3823716025E+06;3.6525111478E+06]; % 0759
case '2',  rr=[918129.385993249;-4346071.26972333;4561977.84513989];
case '3',  rr=[-3.9161393306E+06;3.4071465159E+06;3.6945774922E+06]; % 3064
otherwise, rr=mean(p(:,2:4),1)';
end

% plot errors
%plot_pos(p(:,1),p(:,2:4),rr);
i=find(p(:,end)==2);
plot_pos(p(i,1),p(i,2:4),rr);

moveax;


% plot errors ------------------------------------------------------------------
function plot_pos(time,xs,rrov)
[pos,E]=gpos(rrov);
err=E*(xs(:,1:3)'-repmat(rrov,1,size(xs,1)));
%yl=10;
yl=0.2;
figure, hold('on'), grid('on')
plot(time/3600,err','.-'); %legend({'East (m)','North (m)','Up (m)'});
xlim([time(1),time(end)]/3600);
ylim([-yl,yl]);
xlabel('Time (H)'); ylabel('Position Error (m)');
title('POSITION ERROR');
for n=1:3, rms(n)=sqrt(mean(err(n,~isnan(err(n,:))).^2)); end
text(0,0.99,sprintf('  RMSE : E:%7.4fm N:%7.4fm U:%7.4fm',rms),'units','normalized',...
     'horizontal','left','vertical','top');

% ecef to wgs84 / rotation matrix ----------------------------------------------
function [pos,E]=gpos(r)
RE=6378137; F=1/298.257223563;
e2=F*(2-F); r2=norm(r(1:2)); z=r(3); zk=0; n=0;
while abs(z-zk)>1E-4
    sinp=z/sqrt(r2+z^2);
    n=RE/sqrt(1-e2*sinp^2);
    zk=z; z=r(3)+n*e2*sinp;
end
pos=[atan(z/r2),atan2(r(2),r(1)),sqrt(r2+z^2)-n];
E=Rx(-pi/2-pos(1))*Rz(pi/2+pos(2));
pos(1:2)=pos(1:2)*180/pi;

function R=Rx(t), R=[1,0,0;0,cos(t),sin(t);0,-sin(t),cos(t)];
function R=Rz(t), R=[cos(t),sin(t),0;-sin(t),cos(t),0;0,0,1];
